<?php

    function filtra_decimales( $numerico , $requerido=false ){
       $_numerico = floatval($numerico);
       $_numerico = filter_var($_numerico ,FILTER_SANITIZE_NUMBER_FLOAT, FILTER_FLAG_ALLOW_FRACTION);
       if( filter_var($_numerico , FILTER_VALIDATE_FLOAT) ){
          return $_numerico;
       }else{
         if( $requerido ){
             return 0;
         }else{
             return $_numerico;
         }
       }
    }


    function filtra_correos( $correo , $requerido=flase ){
      $_correo=strval($correo);
      $_correo=filter_var( $_correo, FILTER_SANITIZE_EMAIL);
      if( filter_var( $_correo, FILTER_VALIDATE_EMAIL) ){
         return strtolower( $_correo );  
      }else{
        if( $requerido){
            return false;
        }else{
            return strtolower( $_correo );
        }
      }  
    }


    function filtra_digitos( $valor , $requerido=false ){
        $_valor = intval($valor);
        $_valor = filter_var( $valor , FILTER_SANITIZE_NUMBER_INT);
        if( filter_var($_valor,FILTER_VALIDATE_INT) ){
                return $_valor;
        }else{
            
            if( $requerido ){
                return false;
            }else{
                return $_valor;
            }
        }
    }

	
    function filtra_cadenas( $cadena , $requerido=false ){
        $_cadena = strval($cadena);
        $_cadena = filter_var( $_cadena,FILTER_SANITIZE_STRING,FILTER_FLAG_STRIP_LOW);
        if($_cadena=="" and $requerido ){
            return false;
        }
        return $_cadena;
    }
    

?>